package de.jatitv.opsecurity.cmdManagement;

import de.jatitv.opsecurity.config.languages.SelectMessages;
import de.jatitv.opsecurity.config.config.SelectConfig;
import de.jatitv.opsecurity.system.Load;
import de.jatitv.opsecurity.system.Main;
import de.jatitv.opsecurity.util.TextBuilder;
import de.jatitv.opsecurity.util.send;
import net.md_5.bungee.api.chat.ClickEvent;
import net.md_5.bungee.api.chat.TextComponent;
import org.bukkit.Bukkit;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.plugin.Plugin;

public class Commands {
    private static Plugin plugin = Main.plugin;
    private static String Prefix = Main.Prefix;
    private static String Autor = String.valueOf(Main.Autor);
    private static String Version = Main.Version;
    private static String Spigot = Main.Spigot;
    private static String Discord = Main.Discord;

    public static void mainCommand(CommandSender sender) {
        if (SelectConfig.OnlyOPcanUseThePlugin) {
            if (sender.isOp()) {
                if (sender.hasPermission("opsecurity.admin")) {
                    SelectConfig.Help(sender);
                } else sender.sendMessage(Main.Prefix + "§cYou do not have permission for OPSecurity!");
            } else sender.sendMessage(Main.Prefix + "§cOnly OPs can use OPSecurity!");
        } else {
            if (sender.hasPermission("opsecurity.admin")) {
                SelectConfig.Help(sender);
            } else sender.sendMessage(Main.Prefix + " §cYou do not have permission for OPSecurity!");
        }
    }

    public static void reload(CommandSender sender) {
        if (sender instanceof Player) {
            Player player = (Player) sender;
            if (Main.opHashMap.containsKey(player.getName().toLowerCase())) {
                if (Main.opHashMap.get(player.getName().toLowerCase()).UUID.equals(player.getUniqueId().toString().replace("-", ""))) {
                    send.player(player, SelectMessages.ReloadStart);
                    Bukkit.getConsoleSender().sendMessage(Main.Prefix + "§8-------------------------------");
                    Bukkit.getConsoleSender().sendMessage(Main.Prefix + "§6Plugin reload...");
                    Bukkit.getConsoleSender().sendMessage(Main.Prefix + "§8-------------------------------");
                    Load.loadReload();
                    Bukkit.getConsoleSender().sendMessage(Main.Prefix + "§8-------------------------------");
                    Bukkit.getConsoleSender().sendMessage(Main.Prefix + " §2Plugin successfully reloaded.");
                    Bukkit.getConsoleSender().sendMessage(Main.Prefix + "§8-------------------------------");
                    send.player(player, SelectMessages.ReloadEnd);
                } else sender.sendMessage(Main.Prefix + " §4You are not on the Whitelist!");


            } else sender.sendMessage(Main.Prefix + " §4You are not on the Whitelist!");
        } else {
            Bukkit.getConsoleSender().sendMessage(Main.Prefix + "§8-------------------------------");
            Bukkit.getConsoleSender().sendMessage(Main.Prefix + " §6Plugin reload...");
            Bukkit.getConsoleSender().sendMessage(Main.Prefix + "§8-------------------------------");
            Load.loadReload();
            Bukkit.getConsoleSender().sendMessage(Main.Prefix + "§8-------------------------------");
            Bukkit.getConsoleSender().sendMessage(Main.Prefix + " §2Plugin successfully reloaded.");
            Bukkit.getConsoleSender().sendMessage(Main.Prefix + "§8-------------------------------");
        }

    }

    public static void info(CommandSender sender) {
        sender.sendMessage(Main.Prefix + "§8-------- §4Plugin-Info §8--------");
        sender.sendMessage(Main.Prefix + "§2This plugin was developed by §9JaTiTV");
        sender.sendMessage(Main.Prefix + "§2");
        sender.sendMessage(Main.Prefix + "§2Twitch: §ehttps://www.twitch.tv/jatitv");
        sender.sendMessage(Main.Prefix + "§2Support-Discord: §e" + Main.Discord);
        sender.sendMessage(Main.Prefix + "§2Spigot: §e" + Main.Spigot);
        sender.sendMessage(Main.Prefix + "§2");
        sender.sendMessage(Main.Prefix + "§2Version: §6" + Main.plugin.getDescription().getVersion());
        sender.sendMessage(Main.Prefix + "§8-----------------------------");
    }

    public static void info(CommandSender sender, Boolean onlyOP) {
        Player player = (Player) sender;
        sender.sendMessage(Prefix + "§4======= §8[§4Command§9GUI§8] §4=======");
        sender.sendMessage(Prefix + " §2Autor: §6" + String.valueOf(Autor).replace("[", "").replace("]", ""));

        if (Main.update_version.equalsIgnoreCase(Version)) {
            sender.sendMessage(Prefix + " §2Version: §6" + Version);
        } else {
            sender.sendMessage(Prefix + " §6A new version was found!");
            TextComponent comp = new TextBuilder(Prefix + " §6Your version: §c" + Version + " §7- §6Current version: §a" + Main.update_version)
                    .addHover("§6You can download it here: §e" + Main.Spigot).addClickEvent(ClickEvent.Action.OPEN_URL, Main.Spigot).build();
            player.spigot().sendMessage(comp);
            TextComponent comp2 = new TextBuilder(Prefix + " §6You can find more information on Discord.")
                    .addHover("§e" + Main.Discord).addClickEvent(ClickEvent.Action.OPEN_URL, Main.Discord).build();
            player.spigot().sendMessage(comp2);
        }
        sender.sendMessage(Prefix + " §2Spigot: §6" + Spigot);
        sender.sendMessage(Prefix + " §2Discord: §6" + Discord);
        sender.sendMessage(Prefix + "§4======= §8[§4Command§9GUI§8] §4=======");
    }
}
