// This claas was created by JaTiTV

package de.jatitv.opsecurity.listener;

import de.jatitv.opsecurity.config.config.SelectConfig;
import de.jatitv.opsecurity.system.Main;
import de.jatitv.opsecurity.util.TextBuilder;
import de.jatitv.opsecurity.util.UpdateChecker;
import net.md_5.bungee.api.chat.ClickEvent;
import net.md_5.bungee.api.chat.TextComponent;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.player.*;
import org.bukkit.scheduler.BukkitRunnable;

public class Events implements org.bukkit.event.Listener {

    @EventHandler
    public void CommandSendEvent(PlayerCommandPreprocessEvent event) {
        if (SelectConfig.CheckOnCommand) {
            Player player = event.getPlayer();
            event.setCancelled(Check.onCheck(player, false));
        }
    }
    @EventHandler
    public void PlayerChatEvent(PlayerChatEvent event) {
        if (SelectConfig.CheckOnChat) {
            Player player = event.getPlayer();
            if (Check.onCheck(player, false)){
                if (event.isCancelled()){
                    return;
                }
                event.setCancelled(true);
            }
        }
    }

    @EventHandler
    public void onInteract(PlayerInteractEvent event) {
        if (SelectConfig.CheckOnInteract) {
            Player player = event.getPlayer();
            new BukkitRunnable() {
                @Override
                public void run() {
                    event.setCancelled(Check.onCheck(player, false));
                }
            }.runTaskLater(Main.plugin, 1L);
        }
    }

    @EventHandler
    public void onJoinCheck(PlayerJoinEvent event) {
        if (SelectConfig.CheckOnJoin) {
            Player player = event.getPlayer();
            new BukkitRunnable() {
                @Override
                public void run() {
                   Check.onCheck(player, true);
                }
            }.runTaskLater(Main.plugin, 1L);
        }
    }

    @EventHandler
    public void onJoinEvent(PlayerLoginEvent event) {
        Player player = event.getPlayer();
        String foundVersion = Main.plugin.getDescription().getVersion();
        if (player.hasPermission("opsecurity.updatemsg") || player.isOp()) {
            if (!foundVersion.equals(Main.update_version)) {
                if (SelectConfig.UpdateCheckOnJoin) {
                    new BukkitRunnable() {
                        @Override
                        public void run() {
                            UpdateChecker.sendUpdateMsg(Main.Prefix, foundVersion, Main.update_version, player);
                        }
                    }.runTaskLater(Main.plugin, 200L);
                }
            }
        }
    }
}
